namespace CMSMicroservice.Application.UserCartsCQ.Commands.CreateNewUserCarts;
public class CreateNewUserCartsCommandValidator : AbstractValidator<CreateNewUserCartsCommand>
{
    public CreateNewUserCartsCommandValidator()
    {
        RuleFor(model => model.ProductId)
            .NotNull();
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.Count)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserCartsCommand>.CreateWithOptions((CreateNewUserCartsCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
